#include "comdrawable.h"

ComDrawable::ComDrawable(osg::Drawable *node,
			 bool use_display_list,
			 bool use_vbo) {
    this->affected=node;

    this->use_display_list_old = (bool)node->getUseDisplayList();
    this->use_vbo_old = (bool)node->getUseVertexBufferObjects();
    this->use_display_list_new = use_display_list;
    this->use_vbo_new = use_vbo;

}

void ComDrawable::realExecute() {
    affected->setUseDisplayList(use_display_list_new);
    affected->setUseVertexBufferObjects(use_vbo_new);
}

void ComDrawable::undo() {
    affected->setUseDisplayList(use_display_list_old);
    affected->setUseVertexBufferObjects(use_vbo_old);
}

