#include "comshapedrawable.h"

ComShapeDrawable::ComShapeDrawable(osg::ShapeDrawable *node,
				   bool use_display_list,
				   bool use_vbo,
				   osg::Vec4 colour) {
    this->affected=node;

    this->use_display_list_old = (bool)node->getUseDisplayList();
    this->use_vbo_old = (bool)node->getUseVertexBufferObjects();
    this->colour_old = (osg::Vec4)node->getColor();
    this->use_display_list_new = use_display_list;
    this->use_vbo_new = use_vbo;
    this->colour_new = colour;
}

void ComShapeDrawable::realExecute() {

    affected->setUseDisplayList(use_display_list_new);
    affected->setUseVertexBufferObjects(use_vbo_new);
    affected->setColor(colour_new);
}

void ComShapeDrawable::undo() {

    affected->setUseDisplayList(use_display_list_old);
    affected->setUseVertexBufferObjects(use_vbo_old);
    affected->setColor(colour_old);
}

