#ifndef __ComStateSet_H__
#define __ComStateSet_H__

#include "command.h"
#include <osg/StateSet>

class ComStateSet: public Command {
public:
    typedef std::vector< osg::ref_ptr<osg::StateAttribute> > AttributeList;
    typedef std::vector<AttributeList> TextureAttributeList;
    ComStateSet(osg::StateSet *node,
		osg::StateSet::ModeList modes,
                AttributeList attributes,
		osg::StateSet::TextureModeList texture_modes,
                TextureAttributeList texture_attributes,
		int rendering_hint);
    virtual ~ComStateSet() {}
    virtual void realExecute();
    virtual void undo();
private:
    /** Syncs the state attributes with the modes, adding new modes enabled
     * for the new state attributes added by the user */
    void addModes(osg::StateSet::ModeList &modes, AttributeList &attributes);

    osg::ref_ptr< osg::StateSet > affected;
    //Attributes
    osg::StateSet::ModeList modes_old;
    osg::StateSet::ModeList modes_new;
    osg::StateSet::AttributeList attributes_old;
    AttributeList attributes_new;
    osg::StateSet::TextureModeList texture_modes_old;
    osg::StateSet::TextureModeList texture_modes_new;
    osg::StateSet::TextureAttributeList texture_attributes_old;
    TextureAttributeList texture_attributes_new;
    int rendering_hint_old;
    int rendering_hint_new;

};
#endif //__EdStateSet_H__
