#ifndef __ED_FILE_H__
#define __ED_FILE_H__

#include <editable/attributes/edstring.h>

/** @class EdFile
 * @brief Editable attribute for files. It's almost only an specialization
 *  of EdString to be able to represent both strings and filenames with
 *  different viewers
 */
class EdFile: public EdString {
public:
    EdFile(std::string name, std::string description, std::string _value):
	EdString(name,description,_value){}
    EdFile(std::string name, std::string description):
	EdString(name,description){}

    /** Returns the type of this attribute */
    virtual std::string getType() { return "file"; }

    virtual EditableAttribute *clone() const {
	return new EdFile(getName(),getDescription());
    }
};

#endif
