#include <config.h>
#include <local.h>
#include "edlist.h"

EdList::EdList(std::string name,
	       std::string description):
    EditableAttribute(name, description)
{

}

bool EdList::hasChanged() const {
    bool changed=false;
    List::const_iterator iter;
    for (iter=values.begin();iter!=values.end();iter++) {
	const EditableAttributeList &entry=iter->second;
	EditableAttributeList::const_iterator iter2;
	for (iter2=entry.begin();iter2!=entry.end();iter2++) {
            const EditableAttribute *attr = iter2->get();
	    changed=changed || attr->hasChanged();
	}
    }
    return changed;
}

EditableAttribute *EdList::clone() const {
    EdList *clon = new EdList(getName(), getDescription());
    List::const_iterator iter;
    for (iter=values.begin();iter!=values.end();iter++) {
	const EditableAttributeList &entry=iter->second;
	EditableAttributeList::const_iterator iter2;
        EditableAttributeList newlist;
	for (iter2=entry.begin();iter2!=entry.end();iter2++) {
            const EditableAttribute *attr = iter2->get();
            newlist.push_back(attr->clone());
	}
	clon->add(iter->first, newlist);
    }
    return clon;
}

unsigned EdList::addNew() {
    if (prototype_item.size() == 0) {
	std::cerr << "ERROR: Trying to add an item to a list without prototype. Please, report this bug." << std::endl;
	return 0;
    }
    EditableAttributeList newlist;
    EditableAttributeList::const_iterator iter2;
    for (iter2=prototype_item.begin();iter2!=prototype_item.end();iter2++) {
	const EditableAttribute *attr = iter2->get();
	newlist.push_back(attr->clone());
    }
    add(_("<new>"), newlist);
    return values.size() - 1;
}

void EdList::remove(unsigned i) {
    if (prototype_item.size() == 0) {
	std::cerr << "ERROR: Trying to remove an item from a list without prototype. Please, report this bug." << std::endl;
	return;
    }
    values.erase(values.begin()+i);
}
