#ifndef __ED_TEXT_H__
#define __ED_TEXT_H__

#include <editable/attributes/edstring.h>

/** @class EdText
 * @brief Editable attribute for texts. It's almost only an specialization
 *  of EdString to be able to represent both strings and big texts with
 *  different viewers...
 */
class EdText: public EdString {
public:
    EdText(std::string name, std::string description, std::string _value):
	EdString(name,description,_value){}
    EdText(std::string name, std::string description):
	EdString(name,description){}

    /** Returns the type of this attribute */
    virtual std::string getType() { return "text"; }

    virtual EditableAttribute *clone() const {
	return new EdText(getName(),getDescription());
    }
};

#endif
