
#include "edfragmentprogram.h"

#include <command/comfragmentprogram.h>


void EdFragmentProgram::setObject(osg::Object *object) {
    model=dynamic_cast<osg::FragmentProgram *> (object);
    if (model == 0) {
	std::cerr << "EdFragmentProgram::setObject(): FATAL ERROR: This is not an 'osg::FragmentProgram'" << std::endl;
        throw -1;
    }
    program = new EdText( _("Program"), _("The ARB fragment program"), model->getFragmentProgram() );
    
    list.push_back(program.get());

}

EdFragmentProgram::EdFragmentProgram() {}

EdFragmentProgram::EdFragmentProgram(osg::FragmentProgram *_model) {
    setObject(_model);
}

Command* EdFragmentProgram::compile() {
    return new ComFragmentProgram(model.get(),program->get());

}
void EdFragmentProgram::commit() {
    osg::ref_ptr<Command> com = compile();
    com->execute();

}
