#ifndef __EdFragmentProgram_H__
#define __EdFragmentProgram_H__

#include <config.h>
#include <osg/FragmentProgram>
#include <editable/editableentity.h>
#include <editable/attributes/all.h>
#include <command/command.h>
#include <local.h>

class EdFragmentProgram: public EditableEntity {
public:
    EdFragmentProgram();
    EdFragmentProgram(osg::FragmentProgram *);
    virtual void setObject(osg::Object *object);
    virtual Command *compile();
    virtual void commit();
    virtual EditableAttributeList getAttributes() { return list; }
    inline virtual std::string getName() const { return _("FragmentProgram"); }
    inline virtual EditableEntity *clone() const { return new EdFragmentProgram(); }
    inline virtual void genObject() { setObject(new osg::FragmentProgram()); }
    inline virtual osg::Object *getObject() { return model.get(); }
private:
    osg::ref_ptr< osg::FragmentProgram > model;
    EditableAttributeList list;
    //Attributes
    osg::ref_ptr< EdText > program;
};
#endif //__EdFragmentProgram_H__
