#include <editable/entityfactory.h>
#include "edgeometry.h"
#include "edgeode.h"

void EdGeode::setObject(osg::Object *object) {
    model=dynamic_cast<osg::Geode *> (object);
    if (model == 0) {
	std::cerr << "EdGeode::setObject(): FATAL ERROR: This is not an 'osg::Geode'" << std::endl;
        throw -1;
    }
    drawables = new EdList( _("Geode Drawables"), _("List of drawables of this geode") );
    
    for (unsigned i=0;i<model->getNumDrawables();i++) {
	EditableAttributeList list;
 	osg::ref_ptr<EdReference> drawable;
	drawable = new EdReference( _("Drawable"), _("A Geode Drawable") );
	drawable->addClass(_("Drawable"), new EdGeometry);
        drawable->setInitial(EntityFactory::instance()->findEntity(model->getDrawable(i)));
	list.push_back(drawable.get());
        char s[1024];
	sprintf(s,"%d",i);
	drawables->add(s,list);
    }
    
    list.push_back(drawables.get());
}

EdGeode::EdGeode() {}

EdGeode::EdGeode(osg::Geode *_model) {
    setObject(_model);
}

// Nothing to do
Command* EdGeode::compile() {return 0;}

// Nothing to do
void EdGeode::commit() {}

