#ifndef __EdGeode_H__
#define __EdGeode_H__

#include <config.h>
#include <osg/Geode>
#include <editable/editableentity.h>
#include <editable/attributes/all.h>
#include <command/command.h>
#include <local.h>

class EdGeode: public EditableEntity {
public:
    EdGeode();
    EdGeode(osg::Geode *);
    virtual void setObject(osg::Object *object);
    virtual Command *compile();
    virtual void commit();
    virtual EditableAttributeList getAttributes() { return list; }
    inline virtual std::string getName() const { return _("Geode"); }
    inline virtual EditableEntity *clone() const { return new EdGeode(); }
    inline virtual void genObject() { setObject(new osg::Geode()); }
    inline virtual osg::Object *getObject() { return model.get(); }
private:
    osg::ref_ptr< osg::Geode > model;
    EditableAttributeList list;
    //Attributes
    osg::ref_ptr< EdList > drawables;
};
#endif //__EdGeode_H__
