#ifndef __EdGeometry_H__
#define __EdGeometry_H__

#include <config.h>
#include <osg/Geometry>
#include <editable/editableentity.h>
#include <editable/attributes/all.h>
#include <command/command.h>
#include <local.h>

class EdGeometry: public EditableEntity {
public:
    EdGeometry();
    EdGeometry(osg::Geometry *);
    virtual void setObject(osg::Object *object);
    virtual Command *compile();
    virtual void commit();
    virtual EditableAttributeList getAttributes() { return list; }
    inline virtual std::string getName() const { return _("Geometry"); }
    inline virtual EditableEntity *clone() const { return new EdGeometry(); }
    inline virtual void genObject() { setObject(new osg::Geometry()); }
    inline virtual osg::Object *getObject() { return model.get(); }
private:
    osg::ref_ptr< osg::Geometry > model;
    EditableAttributeList list;
    //Attributes
    osg::ref_ptr< EdBool > use_display_list;
    osg::ref_ptr< EdBool > use_vbo;
    osg::ref_ptr< EdReference > stateset;
};
#endif //__EdGeometry_H__
