
#include "edprojection.h"

#include <command/comprojection.h>


void EdProjection::setObject(osg::Object *object) {
    model=dynamic_cast<osg::Projection *> (object);
    if (model == 0) {
	std::cerr << "EdProjection::setObject(): FATAL ERROR: This is not an 'osg::Projection'" << std::endl;
	throw -1;
    }
    matrix = new EdMatrix( _("Projection Matrix"), _("An OpenGL Projection Matrix") );
    matrix->setInitial(model->getMatrix());

    list.push_back(matrix.get());

}

EdProjection::EdProjection() {}

EdProjection::EdProjection(osg::Projection *_model) {
    setObject(_model);
}

Command *EdProjection::compile() {
    return new ComProjection(model.get(), matrix->get());
}

void EdProjection::commit() {
    osg::ref_ptr<Command> com = compile();
    com->execute();
}
