#ifndef __EdProjection_H__
#define __EdProjection_H__

#include <config.h>
#include <osg/Projection>
#include <editable/editableentity.h>
#include <editable/attributes/all.h>
#include <command/command.h>
#include <local.h>

class EdProjection: public EditableEntity {
public:
    EdProjection();
    EdProjection(osg::Projection *);
    virtual void setObject(osg::Object *object);
    virtual Command *compile();
    virtual void commit();
    virtual EditableAttributeList getAttributes() { return list; }
    inline virtual std::string getName() const { return _("Projection"); }
    inline virtual EditableEntity *clone() const { return new EdProjection(); }
    inline virtual void genObject() { setObject(new osg::Projection()); }
    inline virtual osg::Object *getObject() { return model.get(); }
private:
    osg::ref_ptr< osg::Projection > model;
    EditableAttributeList list;
    //Attributes
    osg::ref_ptr< EdMatrix > matrix;
};
#endif //__EdProjection_H__
