#ifndef __EdShapeDrawable_H__
#define __EdShapeDrawable_H__

#include <config.h>
#include <osg/ShapeDrawable>
#include <editable/editableentity.h>
#include <editable/attributes/all.h>
#include <command/command.h>
#include <local.h>

class EdShapeDrawable: public EditableEntity {
public:
    EdShapeDrawable();
    EdShapeDrawable(osg::ShapeDrawable *);
    virtual void setObject(osg::Object *object);
    virtual Command *compile();
    virtual void commit();
    virtual EditableAttributeList getAttributes() { return list; }
    inline virtual std::string getName() const { return _("ShapeDrawable"); }
    inline virtual EditableEntity *clone() const { return new EdShapeDrawable(); }
    inline virtual void genObject() { setObject(new osg::ShapeDrawable()); }
    inline virtual osg::Object *getObject() { return model.get(); }
private:
    osg::ref_ptr< osg::ShapeDrawable > model;
    EditableAttributeList list;
    //Attributes
    osg::ref_ptr< EdBool > use_display_list;
    osg::ref_ptr< EdBool > use_vbo;
    osg::ref_ptr< EdColour > colour;
    osg::ref_ptr< EdReference > stateset;
};
#endif //__EdShapeDrawable_H__
