
#include "edvertexprogram.h"

#include <command/comvertexprogram.h>


void EdVertexProgram::setObject(osg::Object *object) {
    model=dynamic_cast<osg::VertexProgram *> (object);
    if (model == 0) {
	std::cerr << "EdVertexProgram::setObject(): FATAL ERROR: This is not an 'osg::VertexProgram'" << std::endl;
        throw -1;
    }
    program = new EdText( _("Program"), _("The ARB vertex program"), model->getVertexProgram() );
    
    list.push_back(program.get());

}

EdVertexProgram::EdVertexProgram() {}

EdVertexProgram::EdVertexProgram(osg::VertexProgram *_model) {
    setObject(_model);
}

Command* EdVertexProgram::compile() {
    return new ComVertexProgram(model.get(),program->get());

}
void EdVertexProgram::commit() {
    osg::ref_ptr<Command> com = compile();
    com->execute();

}
