#ifndef __EdVertexProgram_H__
#define __EdVertexProgram_H__

#include <config.h>
#include <osg/VertexProgram>
#include <editable/editableentity.h>
#include <editable/attributes/all.h>
#include <command/command.h>
#include <local.h>

class EdVertexProgram: public EditableEntity {
public:
    EdVertexProgram();
    EdVertexProgram(osg::VertexProgram *);
    virtual void setObject(osg::Object *object);
    virtual Command *compile();
    virtual void commit();
    virtual EditableAttributeList getAttributes() { return list; }
    inline virtual std::string getName() const { return _("VertexProgram"); }
    inline virtual EditableEntity *clone() const { return new EdVertexProgram(); }
    inline virtual void genObject() { setObject(new osg::VertexProgram()); }
    inline virtual osg::Object *getObject() { return model.get(); }
private:
    osg::ref_ptr< osg::VertexProgram > model;
    EditableAttributeList list;
    //Attributes
    osg::ref_ptr< EdText > program;
};
#endif //__EdVertexProgram_H__
