#ifndef __GTK_ED_COLOUR_H__
#define __GTK_ED_COLOUR_H__

#include <editable/attributes/edcolour.h>
#include "gtkedattribute.h"

class GtkEdColour: public GtkEdAttribute {
public:
    GtkEdColour();
    virtual ~GtkEdColour();
    virtual void setAttribute(EditableAttribute *attrib);
    virtual void build();
    virtual GtkEdAttribute *clone() { return new GtkEdColour(); }
    virtual GtkWidget *getWidget() { return widget; }

    void signal_changed(int i);

    // We handle labeling ourselves
    virtual bool needsLabel() { return false; }
private:
    osg::ref_ptr<EdColour> attribute;
    GtkWidget *widget;
    GtkWidget *spin[4];
    unsigned handler_id[4];
    bool handler_assigned;
};

#endif
