#ifndef __GTK_ED_MATRIX_H__
#define __GTK_ED_MATRIX_H__

#include <editable/attributes/edmatrix.h>
#include "gtkedattribute.h"

class GtkEdMatrix: public GtkEdAttribute {
public:
    GtkEdMatrix();
    virtual ~GtkEdMatrix();
    virtual void setAttribute(EditableAttribute *attrib);
    virtual void build();
    virtual GtkEdAttribute *clone() { return new GtkEdMatrix(); }
    virtual GtkWidget *getWidget() { return widget; }

    void signal_changed(int i, int j);
    // We handle labeling ourselves
    virtual bool needsLabel() { return false; }
private:
    GtkWidget *widget;
    osg::ref_ptr<EdMatrix> attribute;
    GtkWidget *spin[4][4];
    unsigned handler_id[4][4];
    bool handler_assigned;
};

#endif
