#ifndef __GTK_ED_REFERENCE_H__
#define __GTK_ED_REFERENCE_H__

#include <editable/attributes/edreference.h>
#include "gtkentityform.h"
#include "gtkedattribute.h"

/** TO-DO ****
 * If the editor is persistent, will fail, it will be adding more and more
 * buttons, should fix this in the future */

class GtkEdReference: public GtkEdAttribute {
public:
    GtkEdReference();
    virtual ~GtkEdReference();
    virtual void setAttribute(EditableAttribute *attrib);
    virtual void build();
    virtual GtkEdAttribute *clone() { return new GtkEdReference(); }
    virtual GtkWidget *getWidget() { return widget; }
    virtual bool needsLabel() { return false; }

    void newPointer();
    void removePointer();

    /// Selects another class for the changeClass operation
    void selectClass(std::string the_class);

    /// Instantiates the selected class referencing this new instance
    void changeClass();
private:
    /** Generates the class selector to change the instance class */
    void genClassesWindow();

    /** Creates and adds the New/Remove buttons to the whole editor */
    void addButtons();

    osg::ref_ptr<GtkEntityForm> entityForm;
    GtkWidget *widget; ///< The whole editor widget
    GtkWidget *frame2; ///< The internal frame where the refenced object is shown
    GtkWidget *vbox; ///< Vertical box where the frame2 and the buttons are
    GtkWidget *buttons; ///< The buttons for changing and removing the referenced
    osg::ref_ptr<EdReference> attribute;
    std::string selected_class;

    GtkWidget *selection_window;
};

#endif
