#include <iostream>
#include <gtk/gtkscrolledwindow.h>
#include <gtk/gtktextview.h>
#include "gtkedtext.h"

static void on_end_user_action (GtkTextBuffer *textbuffer,
				GtkEdText *editor) {
    editor->signal_changed();
}

void GtkEdText::setAttribute(EditableAttribute *attrib) {
    if (widget ==0 ) {
	std::cerr << "setAttribute MUST be called after build()" << std::endl;
	throw -1;
    }
    attribute = dynamic_cast<EdText*>(attrib);
    if (!attribute.valid()) {
	std::cerr << "GtkEdText::build: FATAL ERROR: argument isn't an EdText" << std::endl;
        throw -1;
    }
    if (handler_id != 0xFFFFFFFF) {
        g_signal_handler_disconnect((gpointer) text, handler_id);
        g_signal_handler_disconnect((gpointer) text, handler_id2);
        g_signal_handler_disconnect((gpointer) text, handler_id3);
    }
    GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
    gtk_text_buffer_set_text(buffer,attribute->get().c_str(),-1);

    handler_id3 = g_signal_connect ((gpointer) buffer, "end-user-action",
				   G_CALLBACK (on_end_user_action),
				   this);
}

void GtkEdText::build() {
    widget = gtk_scrolled_window_new (NULL, NULL);
    text = gtk_text_view_new ();
    gtk_container_add (GTK_CONTAINER (widget), text);
 
    gtk_widget_ref(widget);
}

GtkEdText::GtkEdText() {
    widget=0;
    text=0;
    handler_id=0xFFFFFFFF;
    handler_id2=0xFFFFFFFF;
    handler_id3=0xFFFFFFFF;
}

GtkEdText::~GtkEdText() {
    if (handler_id != 0xFFFFFFFF) {
        g_signal_handler_disconnect((gpointer) text, handler_id);
        g_signal_handler_disconnect((gpointer) text, handler_id2);
        g_signal_handler_disconnect((gpointer) text, handler_id3);
    }
    if (widget!=0) gtk_widget_unref(widget);
}

void GtkEdText::signal_changed() {
    if (attribute.valid()) {
	GtkTextIter start, end;
        GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
	gtk_text_buffer_get_start_iter(buffer,&start);
	gtk_text_buffer_get_end_iter(buffer,&end);
	attribute->set(gtk_text_buffer_get_text(buffer,&start,&end,false));
    }
}
